import java.io.*;

import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class Jargoneer extends MIDlet
    implements CommandListener, Runnable {
  private Display mDisplay;

  private Command mExitCommand, mFindCommand, mCancelCommand, mSearchCommand;
  private Command mSearchBackCommand;

  private TextBox mSubmitBox;
  private Form mProgressForm;
  private Form mSearchForm;
  private StringItem mProgressString;

    private Form mHomeForm;
    private StringItem mSearchButton;
  private TextField mSearchField;

  public Jargoneer() {
    SomeClass.doSomething();
    SomeClass.class.getResourceAsStream( "someFile" );

//    SomeClass someClass = new SomeClass();
//    someClass.doSome1();
    mExitCommand = new Command("Exit", Command.EXIT, 0);
    mFindCommand = new Command("Find", Command.SCREEN, 0);
    mSearchCommand = new Command("Search", Command.SCREEN, 0);
    mCancelCommand = new Command("Cancel", Command.CANCEL, 0);
    
    mSubmitBox = new TextBox("Jargoneer", "", 32, 0);
    mSubmitBox.addCommand(mExitCommand);
    mSubmitBox.addCommand(mFindCommand);
    mSubmitBox.addCommand(mSearchCommand);
    mSubmitBox.setCommandListener(this);
    
    mProgressForm = new Form("Lookup progress");
    mProgressString = new StringItem(null, null);
    mProgressForm.append(mProgressString);
    
    mSearchForm = new Form("Search Form");
    mSearchField = new TextField("Search for:", "", 10, TextField.NON_PREDICTIVE);
    mSearchBackCommand = new Command("Back", Command.BACK, 0);
    mSearchForm.append(mSearchField);
    mSearchForm.addCommand(mFindCommand);
    mSearchForm.addCommand(mSearchCommand);
    mSearchForm.addCommand(mSearchBackCommand);
    mSearchForm.setCommandListener(this);
    mSearchButton = new StringItem("Search", "", StringItem.BUTTON);
    mSearchForm.append(mSearchButton);
   
    
    mHomeForm = new Form("Home Form");
  }

  public void startApp() {
    mDisplay = Display.getDisplay(this);
    
    mDisplay.setCurrent(mSubmitBox);
  }

  public void pauseApp() {}

  public void destroyApp(boolean unconditional) {}

  public void commandAction(Command c, Displayable s) {
    if (c == mExitCommand) {
      destroyApp(false);
      notifyDestroyed();
    }
    else if (c == mFindCommand) {
        System.out.println("I am in find command");
      // Show the progress form.
      mDisplay.setCurrent(mProgressForm);
      // Kick off the thread to do the query.
      Thread t = new Thread(this);
      t.start();
    }
    else if (c == mSearchCommand)
    {
        System.out.println("I am in seach command");
        mDisplay.setCurrent(mSearchForm);
    }
    else if (c == mSearchBackCommand)
    {
        System.out.println("I am in seach back button");
        mDisplay.setCurrent(mHomeForm);
    }
  }

  public void run() {
    String word = mSubmitBox.getString();
    String definition;
    
    try { definition = lookUp(word); }
    catch (IOException ioe) {
      Alert report = new Alert(
          "Sorry",
          "Something went wrong and that " +
          "definition could not be retrieved.",
          null, null);
      report.setTimeout(Alert.FOREVER);
      mDisplay.setCurrent(report, mSubmitBox);
      return;
    }
    
    Alert results = new Alert("Definition", definition,
        null, null);
    results.setTimeout(Alert.FOREVER);
    mDisplay.setCurrent(results, mSubmitBox);
  }
  
  private String lookUp1(String word) throws IOException
  {
      InputStream is = getClass().getResourceAsStream("GMMDir.txt");
      String data = "";
      byte [] arr = new byte[100];
      int numRead = is.read(arr);
      while (numRead > 0)
      {
          data = data.concat( new String(arr) );
          numRead = is.read(arr);
      }
      
      return data;
  }
  private String lookUp(String word) throws IOException {
    HttpConnection hc = null;
    InputStream in = null;
    String definition = null;
    
    try {
      // String baseURL = "http://65.215.221.148:8080/wj2/jargoneer?word=";
      // String url = baseURL + word;
      String url = "http://northwest2go.com";
      mProgressString.setText("Connecting...");
      hc = (HttpConnection)Connector.open(url);
      hc.setRequestProperty("Connection", "close");
      in = hc.openInputStream();
      
      mProgressString.setText("Reading...");
      int contentLength = (int)hc.getLength();
      if (contentLength == -1) contentLength = 255;
      byte[] raw = new byte[contentLength];
      int length = in.read(raw);

      // Clean up.
      in.close();
      hc.close();

      definition = new String(raw, 0, length);
    }
    finally {
      try {
        if (in != null) in.close();
        if (hc != null) hc.close();
      }
      catch (IOException ignored) {}
    }
    
    return definition;
  }
}